/**	
	$Author: dizzy $
	$Revision: 1.5 $
	Last updated: $Date: 2000/09/13 11:50:27 $
	
	$Log: CoinsPref.c,v $
	Revision 1.5  2000/09/13 11:50:27  dizzy
	The transaction module is fully functional
	
	Revision 1.4  2000/09/08 10:41:10  dizzy
	Transactiondatabas initial support and column display preferences support
	
	Revision 1.3  2000/09/04 14:23:07  dizzy
	General code cleanup
	
	Revision 1.1  2000/08/21 08:59:30  dizzy
	Reorganised files

	Copyright (C) 2000 Vlad Mereuta <V.C.Mereuta@warwick.ac.uk>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
	
*/

#define __COINS_PREF_C__

#include "CoinsPref.h"

static const UInt16	coins_pref_id=0;	//id for the pref structure above
static const Int16 	coins_pref_ver=1;

palmCoinsPrefType 	coins_pref;	//the structure holds the app's preferences

void Prefs_Get()
{
	UInt16 t=sizeof(coins_pref);
	int ret=PrefGetAppPreferences(PALM_COINS_CREATOR,coins_pref_id,(void*) &coins_pref,&t,true);
	
	if (ret==noPreferenceFound) {
		Prefs_SetDefault();
		Prefs_Save();
	}
}

void Prefs_Save()
{
	PrefSetAppPreferences(PALM_COINS_CREATOR,coins_pref_id,coins_pref_ver,(void*) &coins_pref,sizeof(coins_pref),true);
}

void Prefs_SetDefault()
{
	//set the last update to yesterday
	DateType today;

	//get today's date
	DateSecondsToDate(TimGetSeconds(),& today);
	
	//store yesterday in today
	DateAdjust(&today,-1);
	coins_pref.last_update=today;
	coins_pref.opening_category=dmAllCategories;
	coins_pref.disp_eom_col=false;
	coins_pref.disp_payee=false;
}
