/**	
	$Author: dizzy $
	$Revision: 1.6 $
	Last updated: $Date: 2000/09/08 10:39:52 $
	
	$Log: MiscFunc.h,v $
	Revision 1.6  2000/09/08 10:39:52  dizzy
	Databases are now opened by name.
	
	Revision 1.5  2000/09/04 14:23:07  dizzy
	General code cleanup
	
	Revision 1.3  2000/08/23 12:08:30  dizzy
	Added details dialog for accounts
	
	Revision 1.2  2000/08/21 15:04:20  dizzy
	Fixed more bugs. Added scrolling support
	
	Revision 1.1  2000/08/21 08:59:30  dizzy
	Reorganised files

	Copyright (C) 2000 Vlad Mereuta <V.C.Mereuta@warwick.ac.uk>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
	
*/

#ifndef __MISC_FUNC__
#define __MISC_FUNC__

#include <PalmOS.h>

/// application creator
#define PALM_COINS_CREATOR	'DyCo'


/**
	Sets the category of a given record
	@param db		database to seek the record in
	@param index	the index of the record
	@param cat		the (new) category
*/
void db_SetRecordCategory(DmOpenRef db, UInt16 index, UInt16 cat);

/**
	Returns the category of a given record
	@param db		database to seek the record in
	@param index	the index of the record
	@return	the record category
*/

UInt16 db_GetRecordCategory(DmOpenRef db, UInt16 index);


/**
	opens or creates a database
	@param dbP	reference to the db
	@param type database type
	@param creator database creator
	@param mode	mode in which to open the database
	@param name db name
	@param created on return is set to true if the db had to be created
*/

Err	db_OpenOrCreate(DmOpenRef *dbP, UInt32 type, UInt32 creator, UInt16 mode, UInt16 cardNo, Char* name, Boolean* created);


/**
	Get a 32bit int containg a sum of money in pence and return a pointer
	to a proper formatted string.
	
	the pointer has to be deallocated after use with MemPtrFree
	
*/
Char* Pence2String(Int32 pence);

Int32 String2Pence(Char* sum);

/**
	returns a pointer to a given object in the current form
*/
void* GetObjectPtr(UInt16 objID);

/**
	returns a pointer to a given object in a given form
*/
void*	GetObjectPtrByForm(FormPtr frm,UInt16 objID);

/**
	returns pointer to the text in a given field in the current form
*/
void*	GetTextPtr(UInt16 objID);

FieldPtr SetFieldTextFromHandle(Int16 fieldID, MemHandle txtH);

// Allocates new handle and copies incoming string
FieldPtr SetFieldTextFromStr(Int16 fieldID, const Char* str);

//clears the text from a field:
void  ClearFieldText(Int16 fieldID);
#endif
