/**	
	$Author: dizzy $
	$Revision: 1.6 $
	Last updated: $Date: 2000/09/04 14:23:07 $
	
	$Log: NewAccountForm.c,v $
	Revision 1.6  2000/09/04 14:23:07  dizzy
	General code cleanup

	Copyright (C) 2000 Vlad Mereuta <V.C.Mereuta@warwick.ac.uk>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
	
*/

#include "NewAccountForm.h"

// module globals - placed here to avoid naming conflicy with Accdetails form

static UInt16	selected_cat=dmUnfiledCategory;
static Char		cat_name [dmCategoryLength];
static FormPtr	frm;

Boolean NewAcc_Save()
{	
	accountStructure 	a;
	UInt16				index;

	//if the balance is invalid it will be 0
	a.balance=String2Pence((Char*) GetTextPtr(NEW_ACC_BALANCE));
	a.eom_balance=a.balance;

	a.credit_limit=String2Pence((Char*) GetTextPtr(NEW_ACC_CREDIT));

	a.owner=(Char*) GetTextPtr(NEW_ACC_OWNER);
	if(!a.owner) return false;
	a.bank=(Char*) GetTextPtr(NEW_ACC_BANK);
	if(!a.bank) return false;
	
	a.acname=(Char*) GetTextPtr(NEW_ACC_NAME);
	if(!a.acname) return false;

	index=AccountsDB_NewRecord(&a);
	AccountsDB_SetRecordCategory(index,selected_cat);

	//release record and set the dirty bit
	DmReleaseRecord(AccountsDB_ref, index, true); 

	//recalculate the totals
	AccountsDB_totals.dirty=true;				

	return true;
}

void NewAcc_InitCat()
{
	ControlPtr	ctl;
	
	// Set the label of the category trigger. it defaults to the current category
	// unless the current one is all (in which case it defaults to unfiled)
	if(AccountsDB_current_cat==dmAllCategories) selected_cat=dmUnfiledCategory;
		else selected_cat=AccountsDB_current_cat;
		
	ctl = GetObjectPtrByForm (frm,NEW_ACC_TYPE_TRIGGER);
	CategoryGetName (AccountsDB_ref,selected_cat, cat_name);
	CategorySetTriggerLabel(ctl, cat_name);
//	ErrFatalDisplay("init cat");
	
}

void	NewAcc_SelectCat()
{
	UInt16		category;
	Boolean 	categoryEdited;
	
	// Process the category popup list.  
	category = selected_cat;

	categoryEdited=CategorySelect(AccountsDB_ref,frm, NEW_ACC_TYPE_TRIGGER,NEW_ACC_TYPE_LIST,false,\
		&category,cat_name,1,categoryDefaultEditCategoryString);
	selected_cat=category;
//	ErrFatalDisplay("selectcat");
}

Boolean NewAcc_HandleEvent(EventPtr event)
{
	Boolean 	handled = true;

	// Get the form pointer
	frm = FrmGetActiveForm();

	// Key Events
	switch(event->eType) {

	// Form Open
	case frmOpenEvent:		
		NewAcc_InitCat();

		//draw form
		FrmDrawForm(frm);
		break;
	
	// Controls
	case ctlSelectEvent:
		switch( event->data.ctlSelect.controlID ) {
			case NEW_ACC_TYPE_TRIGGER:		//Select a category
				NewAcc_SelectCat();
				handled = true;
				break;
			case NEW_ACC_OK:
				handled = true;
				//if something went wrong do nothing
				if(! NewAcc_Save()) break;
				//update the main form
				FrmUpdateForm(ACCOUNTS_MAIN_FORM,0);				
				FrmReturnToForm(ACCOUNTS_MAIN_FORM);
				break;
			
			case NEW_ACC_CANCEL:
				//cancel button was pressed;
				//simply return to the main form
				handled = true;
				FrmReturnToForm(ACCOUNTS_MAIN_FORM);
				break;
				
			default:
				handled = false;
		};
		break;	
	// Everything else...
	default:
		handled = false;
	}	
	return handled;
}
