/**	
	$Author: dizzy $
	$Revision: 1.1 $
	Last updated: $Date: 2000/09/08 10:42:54 $
	
	$Log: PreferencesForm.c,v $
	Revision 1.1  2000/09/08 10:42:54  dizzy
	Initial commit.
	
	Copyright (C) 2000 Vlad Mereuta <V.C.Mereuta@warwick.ac.uk>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
	
*/

#include "PreferencesForm.h"

// module globals - placed here to avoid naming conflicy with Accdetails form

static FormPtr	frm;

Boolean PrefForm_HandleEvent(EventPtr event)
{
	Boolean 	handled = true;

	// Get the form pointer
	frm = FrmGetActiveForm();

	// Key Events
	switch(event->eType) {

	// Form Open
	case frmOpenEvent:		
		//draw form
		FrmSetControlValue(frm,FrmGetObjectIndex(frm,PREF_EOM_COL_CBX),coins_pref.disp_eom_col);
		FrmDrawForm(frm);
		break;
	
	// Controls
	case ctlSelectEvent:
		switch( event->data.ctlSelect.controlID ) {
			case PREF_OK:
				handled = true;
				coins_pref.disp_eom_col=FrmGetControlValue(frm,FrmGetObjectIndex(frm,PREF_EOM_COL_CBX));
				//save the new preferences
				Prefs_Save();
				//update the main form
				FrmUpdateForm(ACCOUNTS_MAIN_FORM,0);				
				FrmReturnToForm(ACCOUNTS_MAIN_FORM);
				break;
			
			case PREF_CANCEL:
				//cancel button was pressed;
				//simply return to the main form
				handled = true;
				FrmReturnToForm(ACCOUNTS_MAIN_FORM);
				break;
				
			default:
				handled = false;
		};
		break;	
	// Everything else...
	default:
		handled = false;
	}	
	return handled;
}
