/**	
	$Author: dizzy $
	$Revision: 1.6 $
	Last updated: $Date: 2000/09/04 14:23:07 $
	
	Copyright (C) 2000 Vlad Mereuta <V.C.Mereuta@warwick.ac.uk>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Log:$	
*/

#ifndef __TRANSACTION_DETAILS_FORM__
#define __TRANSACTION_DETAILS_FORM__

#include <PalmOS.h>

#include "AccountsDB.h"
#include "TransactionsDB.h"
#include "MiscFunc.h"
#include "PalmCoinsRsc.h"


///saves the transaction data and updates all the accounts involved
Boolean TransDetails_Save();

/**
	initialises the account list
	@param use_acc_name if true when the static var p_acc is set to a specific account name, that name will be 
	selected by default in the list and displayed by the trigger
*/
void TransDetails_InitAccList(Boolean use_acc_name);

///set the values for some of the fields in the form (from the transaction record)
void TransDetails_SetDefaults();

///initialises the payment methods list
void TransDetails_InitMethods();

///updates the date field from the month/day/year globals
void TransDetails_UpdateDateField();

///sets the default date to the date in the record 
void TransDetails_InitDate();
 
///call the system form to choose a new date
void TransDetails_ChooseDate();

/// event handler for the form
Boolean TransDetails_HandleEvent(EventPtr event);

#endif
