/**	
	$Author: dizzy $
	$Revision: 1.8 $
	Last updated: $Date: 2000/09/08 10:41:10 $
	
	$Log: TransactionsForm.c,v $

	Copyright (C) 2000 Vlad Mereuta <V.C.Mereuta@warwick.ac.uk>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#define __TRANSACTIONS_FORM_C__

#include "TransactionsForm.h"

/// name of the current category
//static Char cat_name [dmCategoryLength];
///this form
static	FormPtr	frm;

UInt32	curr_account;
UInt32	curr_transaction;
Boolean	curr_transaction_exists;

//void	TransactionsForm_InitCat()
//{
//	ControlPtr	ctl;	
	// Set the label of the category trigger.
//	ctl = GetObjectPtr (TRANS_CAT_TRIGGER);
//	CategoryGetName (TransactionsDB_ref, TransactionsDB_current_cat, cat_name);
//	CategorySetTriggerLabel(ctl, cat_name);
//}

//void	TransactionsForm_SelectCat()
//{
//	UInt16		category=TransactionsDB_current_cat;
//	Boolean 	categoryEdited;

	//have to do this due to some odd behaviour 
//	frm = FrmGetActiveForm();
	
//	categoryEdited=CategorySelect(TransactionsDB_ref,frm, ACC_CAT_TRIGGER,ACC_CAT_LIST,true,&category,
//		cat_name,1,categoryDefaultEditCategoryString);
//	if(categoryEdited || category!=TransactionsDB_current_cat) {
//		TransactionsDB_current_cat=category;	
		//recalculate the totals
//		TransactionsDB_totals.dirty=true;			
//	}	
//}

void	TransactionsForm_DisplayTotals()
{
	Char* 			s;
	RectangleType	rp;
		
	RctSetRectangle(&rp,70,129,90,11);
	WinEraseRectangle(&rp,0);

	
	s=Pence2String(AccountsDB_GetBalance(curr_account));
	WinDrawChars(s,StrLen(s),115,129);
	MemPtrFree(s);
	
	s=Pence2String(AccountsDB_GetEomBalance(curr_account));
	WinDrawChars(s,StrLen(s),70,129);
	MemPtrFree(s);	

	//add some lines at the bottom
	WinDrawLine(0,129,160,129);
	WinDrawLine(0,140,160,140);	
}

Boolean TransactionsForm_HandleEvent( EventPtr event )
{
	Boolean 	handled = true;
	ControlPtr	ptr;
	accountStructure as;

	// Get the form pointer
	frm = FrmGetActiveForm();


	// Key Events
	switch(event->eType) {

	// Form Open
	case frmOpenEvent:

		//set the form title to the name of the account
		AccountsDB_GetUnpackedRecord(curr_account,&as);
		FrmSetTitle(frm,as.acname);
		if(coins_pref.disp_payee) 
			FrmSetControlGroupSelection(frm,1,TRANS_OPT_PAYEE);
		else FrmSetControlGroupSelection(frm,1,TRANS_OPT_ACCOUNT);
		curr_transaction_exists=false;
		TransactionsTable_Init();

		//display the category name
		//TransactionsForm_InitCat();
		//draw form

		FrmDrawForm(frm);
		
		//display the running totals
		TransactionsForm_DisplayTotals();
		break;

	case keyDownEvent:
		switch( event->data.keyDown.chr ) {
			case pageUpChr:			// Scroll up key presed?
				//link the hard button functionality to the soft up/down controls
				ptr = GetObjectPtr(TRANS_PGUP);
				CtlHitControl(ptr);
				handled = true;
				break;								
			case pageDownChr:		// Scroll down key presed?						
				ptr = GetObjectPtr(TRANS_PGDN);
				CtlHitControl(ptr);
				handled = true;
				break;
			default:
				handled = false;
		};
		break;
	
	// Controls
	case ctlSelectEvent:
		switch( event->data.ctlSelect.controlID ) {
			case TRANS_NEW:
				FrmPopupForm(NEW_TRANS_FORM);				
				FrmUpdateForm(TRANSACTIONS_FORM,0);
				handled = true;
				break;
			case TRANS_DETAILS:
				FrmPopupForm(TRANS_DETAILS_FORM);				
				FrmUpdateForm(TRANSACTIONS_FORM,0);
				handled = true;
				break;
			case TRANS_ACCTS:
				//erase the up/down arrows 
				CtlSetEnabled(GetObjectPtr(TRANS_PGDN),false);
				CtlSetEnabled(GetObjectPtr(TRANS_PGDN),false);
		        CtlHideControl(GetObjectPtr(TRANS_PGUP));
		        CtlHideControl(GetObjectPtr(TRANS_PGDN));
				FrmUpdateForm(ACCOUNTS_MAIN_FORM,0);				
				FrmReturnToForm(ACCOUNTS_MAIN_FORM);
				handled = true;
				break;				
//			case ACC_CAT_TRIGGER:		//Select a category
//				TransactionsForm_SelectCat();
//				FrmUpdateForm(ACCOUNTS_MAIN_FORM,0);
//				handled = true;
//				break;
			case TRANS_OPT_PAYEE: //switch to payee vieew
				if(coins_pref.disp_payee) break;
				else coins_pref.disp_payee=true;
				Prefs_Save();
				FrmUpdateForm(TRANSACTIONS_FORM,0);
				handled = true;
				break;
			case TRANS_OPT_ACCOUNT: //switch to account view
				if(!coins_pref.disp_payee) break;
				else coins_pref.disp_payee=false;
				Prefs_Save();
				FrmUpdateForm(TRANSACTIONS_FORM,0);
				handled = true;
				break;
				
			case TRANS_PGUP:
				if(TransactionsTable_top_visible_item) {
					if(TransactionsTable_top_visible_item>=TransactionsTable_rows) TransactionsTable_top_visible_item-=TransactionsTable_rows-1;
					else TransactionsTable_top_visible_item=0;
					FrmUpdateForm(TRANSACTIONS_FORM,0);
				}
				handled = true;
				break;								
			case TRANS_PGDN:		// Scroll down control presed?	
				if(TransactionsTable_total_items>TransactionsTable_rows) {					
					if(TransactionsTable_top_visible_item+TransactionsTable_rows-1<=TransactionsTable_total_items) TransactionsTable_top_visible_item+=TransactionsTable_rows-1;
					else TransactionsTable_top_visible_item=TransactionsTable_total_items-TransactionsTable_rows+1;
				
					FrmUpdateForm(TRANSACTIONS_FORM,0);
				}
				handled = true;
				break;
				
			default:
				handled = false;
		}
		break;
	
	// a item in the table was selected
	// should probably be moved in the table files
	case tblSelectEvent:		
		//save the record on the current row into DetailRecord variable
		DmFindRecordByID(TransactionsDB_ref,TblGetRowData(GetObjectPtr(TRANS_TABLE),event->data.tblSelect.row),&TransactionsDB_current_record);

//		if(event->data.tblSelect.column==TransactionsTable_name_col) {
//			FrmPopupForm(ACC_DETAILS_FORM);
//			FrmUpdateForm(ACCOUNTS_MAIN_FORM,0);
//		}
//		else {
//				FrmAlert(NOT_IMPLEMENTED_ALERT);
//				FrmUpdateForm(ACCOUNTS_MAIN_FORM,0);
//				// to be implemented
//		}
//		handled=true;
//		break;
			
	// Menus
	case menuEvent:
		switch (event->data.menu.itemID) {
			case TRANS_MENU_NEW:
//				FrmPopupForm(NEW_ACC_FORM);
				FrmAlert(NOT_IMPLEMENTED_ALERT);
				FrmUpdateForm(ACCOUNTS_MAIN_FORM,0);
				handled=true;
				break;
			default:
				handled = false;
		}
		break;
	
	// Form Close
	case frmCloseEvent:
		CtlSetEnabled(GetObjectPtr(TRANS_PGDN),false);
		CtlSetEnabled(GetObjectPtr(TRANS_PGDN),false);
        CtlHideControl(GetObjectPtr(TRANS_PGUP));
        CtlHideControl(GetObjectPtr(TRANS_PGDN));
		handled = true;
		break;
	
	// Form Update
	case frmUpdateEvent:
		TransactionsTable_Init();
		//display the category name
//		TransactionsForm_InitCat();
		//draw form
		FrmDrawForm(frm);
		//display the running totals
		TransactionsForm_DisplayTotals();
		
		handled = true;
		break;
	
	// Everything else...
	default:
		handled = false;
	}	
	return handled;
}
